package org.gcube.informationsystem.base.impl.relations;

import org.gcube.informationsystem.base.impl.ERImpl;
import org.gcube.informationsystem.base.reference.entities.BaseEntity;
import org.gcube.informationsystem.base.reference.relations.BaseRelation;

public abstract class BaseRelationImpl<S extends BaseEntity, T extends BaseEntity> extends ERImpl implements BaseRelation<S, T> {
	
	/**
	 * Generated Serial Version UID 
	 */
	private static final long serialVersionUID = 28704968813390512L;
	
	protected S source;
	protected T target;

	protected BaseRelationImpl() {
		super();		
	}

	protected BaseRelationImpl(S source, T target) {
		this();
		this.source = source;
		this.target = target;
	}

	@Override
	public S getSource() {
		return source;
	}
	
	@Override
	public void setSource(S source) {
		this.source = source;
	}

	@Override
	public T getTarget() {
		return target;
	}

	@Override
	public void setTarget(T target) {
		this.target = target;
	}

}