package org.gcube.informationsystem.types.reference.entities;

import java.util.List;

import org.gcube.informationsystem.types.annotations.ISProperty;
import org.gcube.informationsystem.types.impl.entities.ResourceTypeDefinitionImpl;
import org.gcube.informationsystem.types.reference.properties.ResourceEntryDefinition;

import com.fasterxml.jackson.databind.annotation.JsonDeserialize;

@JsonDeserialize(as=ResourceTypeDefinitionImpl.class)
public interface ResourceTypeDefinition extends EntityTypeDefinition {
	
	public static final String NAME = "ResourceTypeDefinition"; //ResourceTypeDefinition.class.getSimpleName();
	public static final String DESCRIPTION = "Used to define a Resource Type";
	public static final String VERSION = "1.0.0";
	
	public static final String FACETS_PROPERTY = "facets";
	public static final String RESOURCES_PROPERTY = "resources";
	
	@ISProperty(name = FACETS_PROPERTY, readonly = false, mandatory = true, nullable = false)
	public List<ResourceEntryDefinition> getFacets();
	
	@ISProperty(name = RESOURCES_PROPERTY, readonly = false, mandatory = true, nullable = false)
	public List<ResourceEntryDefinition> getResources();
	
}
